/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_CAN2SWC_H
#define IMPL_TYPE_CAN2SWC_H

#include "impl_type_physical_vcu_info_1_t.h"
#include "impl_type_physical_vcu_info_2_t.h"
#include "impl_type_physical_devstatus_t.h"
#include "impl_type_physical_heading_angle_t.h"
#include "impl_type_physical_ins_sol_result_status_t.h"
#include "impl_type_physical_ins_sol_result_vel_std_t.h"
#include "impl_type_physical_ins_sol_result_vel_t.h"
#include "impl_type_physical_ins_sol_result_angle_std_t.h"
#include "impl_type_physical_ins_sol_result_angle_t.h"
#include "impl_type_physical_ins_sol_result_altitude_t.h"
#include "impl_type_physical_ins_sol_result_longitude_t.h"
#include "impl_type_physical_ins_sol_result_latitude_t.h"
#include "impl_type_physical_ins_sol_result_common_t.h"
#include "impl_type_physical_gnss_sol_result_latency_t.h"
#include "impl_type_physical_gnss_sol_result_spd_t.h"
#include "impl_type_physical_gnss_sol_result_altitude_t.h"
#include "impl_type_physical_gnss_sol_result_longitude_t.h"
#include "impl_type_physical_gnss_sol_result_latitude_t.h"
#include "impl_type_physical_gnss_sol_result_status_t.h"
#include "impl_type_physical_gnss_sol_result_common_t.h"
#include "impl_type_physical_gnss_sol_result_dop_t.h"
#include "impl_type_physical_gnss_sol_result_num_t.h"
#include "impl_type_physical_imu_bias_corrected_common_t.h"
#include "impl_type_physical_imu_bias_corrected_angrate_t.h"
#include "impl_type_physical_imu_bias_corrected_acc_t.h"
#include "impl_type_physical_imu_origin_common_t.h"
#include "impl_type_physical_imu_origin_acc_t.h"
#include "impl_type_physical_imu_origin_gyro_t.h"
#include "impl_type_physical_message_hs_can_100_t.h"
#include "impl_type_physical_message_hs_can_101_t.h"

struct CAN2SWC {
    ::physical_vcu_info_1_t VCU_Info_1_Signals;
    ::physical_vcu_info_2_t VCU_Info_2_Signals;
    ::physical_devstatus_t DEVSTATUS_Signals;
    ::physical_heading_angle_t HEADING_ANGLE_Signals;
    ::physical_ins_sol_result_status_t INS_SOL_RESULT_STATUS_Signals;
    ::physical_ins_sol_result_vel_std_t INS_SOL_RESULT_VEL_STD_Signals;
    ::physical_ins_sol_result_vel_t INS_SOL_RESULT_VEL_Signals;
    ::physical_ins_sol_result_angle_std_t INS_SOL_RESULT_ANGLE_STD_Signals;
    ::physical_ins_sol_result_angle_t INS_SOL_RESULT_ANGLE_Signals;
    ::physical_ins_sol_result_altitude_t INS_SOL_RESULT_ALTITUDE_Signals;
    ::physical_ins_sol_result_longitude_t INS_SOL_RESULT_LONGITUDE_Signals;
    ::physical_ins_sol_result_latitude_t INS_SOL_RESULT_LATITUDE_Signals;
    ::physical_ins_sol_result_common_t INS_SOL_RESULT_COMMON_Signals;
    ::physical_gnss_sol_result_latency_t GNSS_SOL_RESULT_LATENCY_Signals;
    ::physical_gnss_sol_result_spd_t GNSS_SOL_RESULT_SPD_Signals;
    ::physical_gnss_sol_result_altitude_t GNSS_SOL_RESULT_ALTITUDE_Signals;
    ::physical_gnss_sol_result_longitude_t GNSS_SOL_RESULT_LONGITUDE_Signals;
    ::physical_gnss_sol_result_latitude_t GNSS_SOL_RESULT_LATITUDE_Signals;
    ::physical_gnss_sol_result_status_t GNSS_SOL_RESULT_STATUS_Signals;
    ::physical_gnss_sol_result_common_t GNSS_SOL_RESULT_COMMON_Signals;
    ::physical_gnss_sol_result_dop_t GNSS_SOL_RESULT_DOP_Signals;
    ::physical_gnss_sol_result_num_t GNSS_SOL_RESULT_NUM_Signals;
    ::physical_imu_bias_corrected_common_t IMU_BIAS_CORRECTED_COMMON_Signals;
    ::physical_imu_bias_corrected_angrate_t IMU_BIAS_CORRECTED_ANGRATE_Signals;
    ::physical_imu_bias_corrected_acc_t IMU_BIAS_CORRECTED_ACC_Signals;
    ::physical_imu_origin_common_t IMU_ORIGIN_COMMON_Signals;
    ::physical_imu_origin_acc_t IMU_ORIGIN_ACC_Signals;
    ::physical_imu_origin_gyro_t IMU_ORIGIN_GYRO_Signals;
    ::physical_message_hs_can_100_t Message_HS_CAN_100_Signals;
    ::physical_message_hs_can_101_t Message_HS_CAN_101_Signals;

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(VCU_Info_1_Signals);
        fun(VCU_Info_2_Signals);
        fun(DEVSTATUS_Signals);
        fun(HEADING_ANGLE_Signals);
        fun(INS_SOL_RESULT_STATUS_Signals);
        fun(INS_SOL_RESULT_VEL_STD_Signals);
        fun(INS_SOL_RESULT_VEL_Signals);
        fun(INS_SOL_RESULT_ANGLE_STD_Signals);
        fun(INS_SOL_RESULT_ANGLE_Signals);
        fun(INS_SOL_RESULT_ALTITUDE_Signals);
        fun(INS_SOL_RESULT_LONGITUDE_Signals);
        fun(INS_SOL_RESULT_LATITUDE_Signals);
        fun(INS_SOL_RESULT_COMMON_Signals);
        fun(GNSS_SOL_RESULT_LATENCY_Signals);
        fun(GNSS_SOL_RESULT_SPD_Signals);
        fun(GNSS_SOL_RESULT_ALTITUDE_Signals);
        fun(GNSS_SOL_RESULT_LONGITUDE_Signals);
        fun(GNSS_SOL_RESULT_LATITUDE_Signals);
        fun(GNSS_SOL_RESULT_STATUS_Signals);
        fun(GNSS_SOL_RESULT_COMMON_Signals);
        fun(GNSS_SOL_RESULT_DOP_Signals);
        fun(GNSS_SOL_RESULT_NUM_Signals);
        fun(IMU_BIAS_CORRECTED_COMMON_Signals);
        fun(IMU_BIAS_CORRECTED_ANGRATE_Signals);
        fun(IMU_BIAS_CORRECTED_ACC_Signals);
        fun(IMU_ORIGIN_COMMON_Signals);
        fun(IMU_ORIGIN_ACC_Signals);
        fun(IMU_ORIGIN_GYRO_Signals);
        fun(Message_HS_CAN_100_Signals);
        fun(Message_HS_CAN_101_Signals);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(VCU_Info_1_Signals);
        fun(VCU_Info_2_Signals);
        fun(DEVSTATUS_Signals);
        fun(HEADING_ANGLE_Signals);
        fun(INS_SOL_RESULT_STATUS_Signals);
        fun(INS_SOL_RESULT_VEL_STD_Signals);
        fun(INS_SOL_RESULT_VEL_Signals);
        fun(INS_SOL_RESULT_ANGLE_STD_Signals);
        fun(INS_SOL_RESULT_ANGLE_Signals);
        fun(INS_SOL_RESULT_ALTITUDE_Signals);
        fun(INS_SOL_RESULT_LONGITUDE_Signals);
        fun(INS_SOL_RESULT_LATITUDE_Signals);
        fun(INS_SOL_RESULT_COMMON_Signals);
        fun(GNSS_SOL_RESULT_LATENCY_Signals);
        fun(GNSS_SOL_RESULT_SPD_Signals);
        fun(GNSS_SOL_RESULT_ALTITUDE_Signals);
        fun(GNSS_SOL_RESULT_LONGITUDE_Signals);
        fun(GNSS_SOL_RESULT_LATITUDE_Signals);
        fun(GNSS_SOL_RESULT_STATUS_Signals);
        fun(GNSS_SOL_RESULT_COMMON_Signals);
        fun(GNSS_SOL_RESULT_DOP_Signals);
        fun(GNSS_SOL_RESULT_NUM_Signals);
        fun(IMU_BIAS_CORRECTED_COMMON_Signals);
        fun(IMU_BIAS_CORRECTED_ANGRATE_Signals);
        fun(IMU_BIAS_CORRECTED_ACC_Signals);
        fun(IMU_ORIGIN_COMMON_Signals);
        fun(IMU_ORIGIN_ACC_Signals);
        fun(IMU_ORIGIN_GYRO_Signals);
        fun(Message_HS_CAN_100_Signals);
        fun(Message_HS_CAN_101_Signals);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("VCU_Info_1_Signals", VCU_Info_1_Signals);
        fun("VCU_Info_2_Signals", VCU_Info_2_Signals);
        fun("DEVSTATUS_Signals", DEVSTATUS_Signals);
        fun("HEADING_ANGLE_Signals", HEADING_ANGLE_Signals);
        fun("INS_SOL_RESULT_STATUS_Signals", INS_SOL_RESULT_STATUS_Signals);
        fun("INS_SOL_RESULT_VEL_STD_Signals", INS_SOL_RESULT_VEL_STD_Signals);
        fun("INS_SOL_RESULT_VEL_Signals", INS_SOL_RESULT_VEL_Signals);
        fun("INS_SOL_RESULT_ANGLE_STD_Signals", INS_SOL_RESULT_ANGLE_STD_Signals);
        fun("INS_SOL_RESULT_ANGLE_Signals", INS_SOL_RESULT_ANGLE_Signals);
        fun("INS_SOL_RESULT_ALTITUDE_Signals", INS_SOL_RESULT_ALTITUDE_Signals);
        fun("INS_SOL_RESULT_LONGITUDE_Signals", INS_SOL_RESULT_LONGITUDE_Signals);
        fun("INS_SOL_RESULT_LATITUDE_Signals", INS_SOL_RESULT_LATITUDE_Signals);
        fun("INS_SOL_RESULT_COMMON_Signals", INS_SOL_RESULT_COMMON_Signals);
        fun("GNSS_SOL_RESULT_LATENCY_Signals", GNSS_SOL_RESULT_LATENCY_Signals);
        fun("GNSS_SOL_RESULT_SPD_Signals", GNSS_SOL_RESULT_SPD_Signals);
        fun("GNSS_SOL_RESULT_ALTITUDE_Signals", GNSS_SOL_RESULT_ALTITUDE_Signals);
        fun("GNSS_SOL_RESULT_LONGITUDE_Signals", GNSS_SOL_RESULT_LONGITUDE_Signals);
        fun("GNSS_SOL_RESULT_LATITUDE_Signals", GNSS_SOL_RESULT_LATITUDE_Signals);
        fun("GNSS_SOL_RESULT_STATUS_Signals", GNSS_SOL_RESULT_STATUS_Signals);
        fun("GNSS_SOL_RESULT_COMMON_Signals", GNSS_SOL_RESULT_COMMON_Signals);
        fun("GNSS_SOL_RESULT_DOP_Signals", GNSS_SOL_RESULT_DOP_Signals);
        fun("GNSS_SOL_RESULT_NUM_Signals", GNSS_SOL_RESULT_NUM_Signals);
        fun("IMU_BIAS_CORRECTED_COMMON_Signals", IMU_BIAS_CORRECTED_COMMON_Signals);
        fun("IMU_BIAS_CORRECTED_ANGRATE_Signals", IMU_BIAS_CORRECTED_ANGRATE_Signals);
        fun("IMU_BIAS_CORRECTED_ACC_Signals", IMU_BIAS_CORRECTED_ACC_Signals);
        fun("IMU_ORIGIN_COMMON_Signals", IMU_ORIGIN_COMMON_Signals);
        fun("IMU_ORIGIN_ACC_Signals", IMU_ORIGIN_ACC_Signals);
        fun("IMU_ORIGIN_GYRO_Signals", IMU_ORIGIN_GYRO_Signals);
        fun("Message_HS_CAN_100_Signals", Message_HS_CAN_100_Signals);
        fun("Message_HS_CAN_101_Signals", Message_HS_CAN_101_Signals);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("VCU_Info_1_Signals", VCU_Info_1_Signals);
        fun("VCU_Info_2_Signals", VCU_Info_2_Signals);
        fun("DEVSTATUS_Signals", DEVSTATUS_Signals);
        fun("HEADING_ANGLE_Signals", HEADING_ANGLE_Signals);
        fun("INS_SOL_RESULT_STATUS_Signals", INS_SOL_RESULT_STATUS_Signals);
        fun("INS_SOL_RESULT_VEL_STD_Signals", INS_SOL_RESULT_VEL_STD_Signals);
        fun("INS_SOL_RESULT_VEL_Signals", INS_SOL_RESULT_VEL_Signals);
        fun("INS_SOL_RESULT_ANGLE_STD_Signals", INS_SOL_RESULT_ANGLE_STD_Signals);
        fun("INS_SOL_RESULT_ANGLE_Signals", INS_SOL_RESULT_ANGLE_Signals);
        fun("INS_SOL_RESULT_ALTITUDE_Signals", INS_SOL_RESULT_ALTITUDE_Signals);
        fun("INS_SOL_RESULT_LONGITUDE_Signals", INS_SOL_RESULT_LONGITUDE_Signals);
        fun("INS_SOL_RESULT_LATITUDE_Signals", INS_SOL_RESULT_LATITUDE_Signals);
        fun("INS_SOL_RESULT_COMMON_Signals", INS_SOL_RESULT_COMMON_Signals);
        fun("GNSS_SOL_RESULT_LATENCY_Signals", GNSS_SOL_RESULT_LATENCY_Signals);
        fun("GNSS_SOL_RESULT_SPD_Signals", GNSS_SOL_RESULT_SPD_Signals);
        fun("GNSS_SOL_RESULT_ALTITUDE_Signals", GNSS_SOL_RESULT_ALTITUDE_Signals);
        fun("GNSS_SOL_RESULT_LONGITUDE_Signals", GNSS_SOL_RESULT_LONGITUDE_Signals);
        fun("GNSS_SOL_RESULT_LATITUDE_Signals", GNSS_SOL_RESULT_LATITUDE_Signals);
        fun("GNSS_SOL_RESULT_STATUS_Signals", GNSS_SOL_RESULT_STATUS_Signals);
        fun("GNSS_SOL_RESULT_COMMON_Signals", GNSS_SOL_RESULT_COMMON_Signals);
        fun("GNSS_SOL_RESULT_DOP_Signals", GNSS_SOL_RESULT_DOP_Signals);
        fun("GNSS_SOL_RESULT_NUM_Signals", GNSS_SOL_RESULT_NUM_Signals);
        fun("IMU_BIAS_CORRECTED_COMMON_Signals", IMU_BIAS_CORRECTED_COMMON_Signals);
        fun("IMU_BIAS_CORRECTED_ANGRATE_Signals", IMU_BIAS_CORRECTED_ANGRATE_Signals);
        fun("IMU_BIAS_CORRECTED_ACC_Signals", IMU_BIAS_CORRECTED_ACC_Signals);
        fun("IMU_ORIGIN_COMMON_Signals", IMU_ORIGIN_COMMON_Signals);
        fun("IMU_ORIGIN_ACC_Signals", IMU_ORIGIN_ACC_Signals);
        fun("IMU_ORIGIN_GYRO_Signals", IMU_ORIGIN_GYRO_Signals);
        fun("Message_HS_CAN_100_Signals", Message_HS_CAN_100_Signals);
        fun("Message_HS_CAN_101_Signals", Message_HS_CAN_101_Signals);
    }

    friend bool operator==(const ::CAN2SWC& lhs, const ::CAN2SWC& rhs) noexcept
    {
        return (lhs.VCU_Info_1_Signals == rhs.VCU_Info_1_Signals) && (lhs.VCU_Info_2_Signals == rhs.VCU_Info_2_Signals) && (lhs.DEVSTATUS_Signals == rhs.DEVSTATUS_Signals) && (lhs.HEADING_ANGLE_Signals == rhs.HEADING_ANGLE_Signals) && (lhs.INS_SOL_RESULT_STATUS_Signals == rhs.INS_SOL_RESULT_STATUS_Signals) && (lhs.INS_SOL_RESULT_VEL_STD_Signals == rhs.INS_SOL_RESULT_VEL_STD_Signals) && (lhs.INS_SOL_RESULT_VEL_Signals == rhs.INS_SOL_RESULT_VEL_Signals) && (lhs.INS_SOL_RESULT_ANGLE_STD_Signals == rhs.INS_SOL_RESULT_ANGLE_STD_Signals) && (lhs.INS_SOL_RESULT_ANGLE_Signals == rhs.INS_SOL_RESULT_ANGLE_Signals) && (lhs.INS_SOL_RESULT_ALTITUDE_Signals == rhs.INS_SOL_RESULT_ALTITUDE_Signals) && (lhs.INS_SOL_RESULT_LONGITUDE_Signals == rhs.INS_SOL_RESULT_LONGITUDE_Signals) && (lhs.INS_SOL_RESULT_LATITUDE_Signals == rhs.INS_SOL_RESULT_LATITUDE_Signals) && (lhs.INS_SOL_RESULT_COMMON_Signals == rhs.INS_SOL_RESULT_COMMON_Signals) && (lhs.GNSS_SOL_RESULT_LATENCY_Signals == rhs.GNSS_SOL_RESULT_LATENCY_Signals) && (lhs.GNSS_SOL_RESULT_SPD_Signals == rhs.GNSS_SOL_RESULT_SPD_Signals) && (lhs.GNSS_SOL_RESULT_ALTITUDE_Signals == rhs.GNSS_SOL_RESULT_ALTITUDE_Signals) && (lhs.GNSS_SOL_RESULT_LONGITUDE_Signals == rhs.GNSS_SOL_RESULT_LONGITUDE_Signals) && (lhs.GNSS_SOL_RESULT_LATITUDE_Signals == rhs.GNSS_SOL_RESULT_LATITUDE_Signals) && (lhs.GNSS_SOL_RESULT_STATUS_Signals == rhs.GNSS_SOL_RESULT_STATUS_Signals) && (lhs.GNSS_SOL_RESULT_COMMON_Signals == rhs.GNSS_SOL_RESULT_COMMON_Signals) && (lhs.GNSS_SOL_RESULT_DOP_Signals == rhs.GNSS_SOL_RESULT_DOP_Signals) && (lhs.GNSS_SOL_RESULT_NUM_Signals == rhs.GNSS_SOL_RESULT_NUM_Signals) && (lhs.IMU_BIAS_CORRECTED_COMMON_Signals == rhs.IMU_BIAS_CORRECTED_COMMON_Signals) && (lhs.IMU_BIAS_CORRECTED_ANGRATE_Signals == rhs.IMU_BIAS_CORRECTED_ANGRATE_Signals) && (lhs.IMU_BIAS_CORRECTED_ACC_Signals == rhs.IMU_BIAS_CORRECTED_ACC_Signals) && (lhs.IMU_ORIGIN_COMMON_Signals == rhs.IMU_ORIGIN_COMMON_Signals) && (lhs.IMU_ORIGIN_ACC_Signals == rhs.IMU_ORIGIN_ACC_Signals) && (lhs.IMU_ORIGIN_GYRO_Signals == rhs.IMU_ORIGIN_GYRO_Signals) && (lhs.Message_HS_CAN_100_Signals == rhs.Message_HS_CAN_100_Signals) && (lhs.Message_HS_CAN_101_Signals == rhs.Message_HS_CAN_101_Signals);
    }
};


#endif // IMPL_TYPE_CAN2SWC_H
